alter table emp
add constraint check_comm_under_30perc
check (nvl(comm,0) < 0.3* sal)

alter table emp
add constraint check_comm_under_30perc
check (nvl(comm,0) < 0.3* sal)



ALTER TABLE
   patient
ADD (
   CONSTRAINT
      phone_number_format
   CHECK
       (REGEXP_LIKE(patient_phone,
        '^\([[:digit:]]{3}\) [[:digit:]]{3}-[[:digit:]]{4}$')));
        
ALTER TABLE
   EMP
ADD (
   CONSTRAINT
      email_address
   CHECK
       (REGEXP_LIKE (text, '[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{2,4}'))
       
       
       

create type number_tbl as table of number



   
create or replace
procedure val_salmax_in_dept
( p_deptno in number
) is
  l_bad_count number;
begin
  select count(*)
  into   l_bad_count
  from   ( select avg(sal) sal_avg
           ,      max(sal) max_sal
           from   emp
           where  deptno = p_deptno
         )
  where  max_sal >= 1.8 * sal_avg;
  if l_bad_count > 0
  then
    raise_application_error( -20099, 'Business Rule Violation: in Department '||p_deptno
                           ||': Maximum Salary may not be more than 1.8 times average');
  end if;
end val_salmax_in_dept; 


create or replace 
trigger br_on_emp_ctrg
for insert or update or delete on emp
compound trigger 
  l_deptno_tbl number_tbl:= number_tbl();
  before statement is
  begin
    null;
  end before statement;
  before each row is
  begin
    if updating('DEPTNO')
    then
      l_deptno_tbl.extend();
      l_deptno_tbl(l_deptno_tbl.last):= :old.deptno;
    end if;
      l_deptno_tbl.extend();
      l_deptno_tbl(l_deptno_tbl.last):= nvl(:new.deptno, :old.deptno);
  end before each row;
  after each row is
  begin
    null;
  end after each row;
  after statement is
  begin
    for i in 1.. l_deptno_tbl.last loop 
      val_salmax_in_dept(l_deptno_tbl(i));
    end loop;
  end after statement;
end br_on_emp_ctrg;
