package nl.amis.email;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;


import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.Properties;

import javax.mail.Flags;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Part;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.internet.InternetAddress;

public class EmailReceiver {

    private static void log(String msg) {
        result = result + ";" + msg;
    }
    private static String result = "start;";

    public static String receive(String popServer, String popUser,
                                 String popPassword) throws Exception {

//        popServer = "localhost";
//        popUser = "maggie@stmatthews.com";
//        popPassword = "maggiemaggie";
//        
        int numberOfMessages = 0;
        Store store = null;
        Folder folder = null;
        try {
            // -- Get hold of the default session --
            Properties props = System.getProperties();
            log("properties");
            Session session = Session.getDefaultInstance(props, null);
            log("session");
            // -- Get hold of a POP3 message store, and connect to it --
            store = session.getStore("pop3");
            log("store");
            store.connect(popServer, popUser, popPassword);

            // -- Try to get hold of the default folder --
            folder = store.getDefaultFolder();
            log("folder");
            if (folder == null)
                throw new Exception("No default folder");
            // -- ...and its INBOX --
            folder = folder.getFolder("INBOX");
            if (folder == null)
                throw new Exception("No POP3 INBOX");
            // -- Open the folder for read only --
            folder.open(Folder.READ_WRITE);
            log("folder open");
            numberOfMessages = folder.getMessageCount();
            System.out.println("# of email messages " + numberOfMessages);
            log("msg count " + numberOfMessages);
            // -- Get the message wrappers and process them --
            Message[] msgs = folder.getMessages();
            for (int msgNum = 0; msgNum < msgs.length; msgNum++) {
                printMessage(msgs[msgNum]);
                log(msgs[msgNum].getSubject());
                log("go ins");
                insertEmail(msgs[msgNum]);
                // delete the email after it has been processed
                msgs[msgNum].setFlag(Flags.Flag.DELETED, true);
              
            }
            return result;
        } catch (Exception ex) {
            log(ex.getMessage());
            ex.printStackTrace();
            throw (ex);
        } finally {
            log("finally");
            // -- Close down nicely --
            try {
                if (folder != null)
                    folder.close(true);
                if (store != null)
                    store.close();
            } catch (Exception ex2) {
                log(ex2.getMessage());
                ex2.printStackTrace();
            }
            return result;
        }
    }

    public static void main(String[] args) {
        try {
            String popServer = "localhost";
            String popUser = "maggie@stmatthews.com";
            String popPassword = "maggiemaggie";
            String result = receive(popServer, popUser, popPassword);
            System.out.println(result);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        System.exit(0);
    }

    public static void printMessage(Message message) {
        try {
            // Get the header information
            String from =
                ((InternetAddress)message.getFrom()[0]).getPersonal();
            Date sent = (Date)message.getSentDate();
            if (from == null)
                from = ((InternetAddress)message.getFrom()[0]).getAddress();

            System.out.println(message.getReceivedDate());
            System.out.println(sent);

            System.out.println("FROM: " + from);
            String subject = message.getSubject();
            System.out.println("SUBJECT: " + subject);
            // -- Get the message part (i.e. the message itself) --
            Part messagePart = message;
            Object content = messagePart.getContent();
            // -- or its first body part if it is a multipart message --
            if (content instanceof Multipart) {
                messagePart = ((Multipart)content).getBodyPart(0);
                System.out.println("[ Multipart Message ]");
            }
            // -- Get the content type --
            String contentType = messagePart.getContentType();
            // -- If the content is plain text, we can print it --
            System.out.println("CONTENT:" + contentType);
            if (contentType.startsWith("text/plain") ||
                contentType.startsWith("text/html")) {
                InputStream is = messagePart.getInputStream();
                BufferedReader reader =
                    new BufferedReader(new InputStreamReader(is));
                String thisLine = reader.readLine();
                while (thisLine != null) {
                    System.out.println(thisLine);
                    thisLine = reader.readLine();
                }
            }
            String cData = message.getContent().toString();
            String to = message.getAllRecipients()[0].toString();
            System.out.println("-----------------------------");


        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void insertEmail(Message message) {
      String from=null;
      String fromAddress=null;
        try {
            from = ((InternetAddress)message.getFrom()[0]).getPersonal();
          fromAddress = ((InternetAddress)message.getFrom()[0]).getAddress();
          if (from == null)
            from = ((InternetAddress)message.getFrom()[0]).getAddress();
        } catch (MessagingException e) {
            log(e.getMessage());
        }
        log(from+";"+fromAddress);
        Date sent=null;
        try {
            sent =  new java.sql.Date( message.getSentDate().getTime());
        } catch (MessagingException e) {
          log(e.getMessage());
        } catch (Exception e) {
          log(e.getMessage());
        }
log(sent.toString());
      String subject=null;
        try {
            subject = message.getSubject();
        } catch (MessagingException e) {
          log(e.getMessage());
        }
        log(subject);

      String cData=null;
      String to=null;
        try {
            cData = message.getContent().toString();
         to = message.getAllRecipients()[0].toString();
} catch (IOException e) {
          log(e.getMessage());

        } catch (MessagingException e) {
          log(e.getMessage());

        }
log("to and content "+to)        ;

        //String insertStatement = INSERT INTO EMAILS ( sent_date , subject , contents , from_sender , to_adressee) VALUES(:sent,:subject,:cData, :from,:to)
        String insertStatement =
            "INSERT INTO SCOTT.EMAILS ( sent_date , subject , contents , from_sender , to_adressee, from_address) " +
            "VALUES(?,?,?,?,?,?)";
        log(insertStatement);
        try {

            Connection conn =
                DriverManager.getConnection("jdbc:default:connection:");
            log("conn");
            
            
            PreparedStatement stmt = conn.prepareStatement(insertStatement);
            log("stm");
            stmt.setDate(1, sent);
            log("date: ");
          stmt.setString(2, subject);
          log("subj");
          stmt.setString(3, cData);
          log("content");
          stmt.setString(4, from);
          log("from");
          stmt.setString(5, to);
          log("to");
          stmt.setString(6, fromAddress);
          log("fromAddress");

            stmt.executeUpdate();
            log("upd");
            stmt.close();
            log("inserted email row");
        } catch (SQLException e) {
            log("SQLException " + e.getMessage() + "::" + e.getErrorCode() +
                e.getSQLState() + e.getLocalizedMessage());
            System.err.println(e.getMessage());
        } catch (Exception e) {
            log(e.getMessage());
            System.err.println(e.getMessage());
        }

    }

}

