package com.hrm.api;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.Properties;

import oracle.jdbc.OracleTypes;

public class DepartmentFetcher {

    private String userName = "scott";
    private String password = "tiger";

    public Connection getConnection() throws SQLException {
        Connection conn = null;
        Properties connectionProps = new Properties();
        connectionProps.put("user", this.userName);
        connectionProps.put("password", this.password);

        conn =
DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:orcl",
                            connectionProps);


        System.out.println("Connected to database");
        return conn;
    }

    public void fetchDepartments(int deptno) throws SQLException {
        CallableStatement stmt=null;
        Connection conn=null;
        try {
            conn = getConnection();
            String query = "begin ? := hrm_api.get_dept_data(?); end;";
            stmt = conn.prepareCall(query);
            // register the type of the out param - an Oracle specific type
            stmt.registerOutParameter(1, OracleTypes.CURSOR);
            // set the deptno in param
            stmt.setInt(2, deptno);
            // execute and retrieve the result set
            stmt.execute();
            ResultSet rs = (ResultSet)stmt.getObject(1);
            while (rs.next()) {
                System.out.println(rs.getString(2) + "\t" + rs.getInt(1) +
                                   "\t" + rs.getString(3));
                ResultSet staff = (ResultSet)rs.getObject(4);
                System.out.println("** Staff");
                while (staff.next()) {
                    System.out.println("    "+staff.getString(2) + "\t" +
                                       staff.getInt(1) + "\t" +
                                       staff.getInt(3) + "\t" +
                                       staff.getString(4));
                  ResultSet subordinates = (ResultSet)staff.getObject(5);
                  if (subordinates != null)
                      System.out.println("    **** Subordinates");
                      while (subordinates.next()) {
                          System.out.println("          "+subordinates.getString(2) + "\t" +
                                             subordinates.getInt(1) + "\t" +
                                             subordinates.getString(3));
                      }
                }
            }
          stmt.close();
          conn.close();

        } catch (Throwable t) {
            // Insert Appropriate Error Handling Here
        } finally {
            // The finally clause is always executed - even in error
            // conditions PreparedStatements and Connections will always be closed
            try {
                if (stmt != null)
                    stmt.close();
            } catch (Exception e) {
            }

            try {
                if (conn != null)
                    conn.close();
            } catch (Exception e) {
            }
        }
    }


  
  public static void main(String[] args) throws SQLException {
        DepartmentFetcher df =new DepartmentFetcher();
        
        df.fetchDepartments(20);
        
    }
}
