package nl.amis.plsql;

import java.sql.CallableStatement;
import java.sql.SQLException;
import java.sql.Types;


public class HelloWorldCaller {
    
    
    
    /*
     * make a call to stored procedure 
     *   function hello_world( p_name in varchar2) return varchar2
     */
    public String helloWorld(String name) throws SQLException {
      String query = "{call ? := hello_world(?)}";
      CallableStatement cs = ConnectionManager.getConnection().prepareCall(query);
      cs.registerOutParameter(1, Types.CHAR);
      cs.setString(2, name);
      cs.execute();
      
      Object rs = cs.getObject(1);
      return rs.toString();
    }

  public String helloWorldProc(String name) throws SQLException {
    String query = "{call hello_world_proc(?,?)}";
    CallableStatement cs = ConnectionManager.getConnection().prepareCall(query);
    cs.setString(1, name);
    cs.registerOutParameter(2, Types.CHAR);
    cs.execute();
    
    Object rs = cs.getObject(2);
    return rs.toString();
  }

    
   public static void main(String[] args) throws SQLException {
      System.out.println("Calling Hello World Proc for John Doe. The result: "
                         + new HelloWorldCaller().helloWorldProc("John Doe"));
      System.out.println("Calling Hello World for John Doe. The result: "
                         + new HelloWorldCaller().helloWorld("John Doe"));
    }
}
