package view.nl.amis.webcache;

import java.io.IOException;
import java.io.PrintWriter;

import java.util.List;

import javax.ejb.EJB;

import javax.servlet.*;
import javax.servlet.http.*;

import nl.amis.hrm.model.Employee;
import nl.amis.hrm.model.HrmSessionEJB;

public class ShowEmployees extends HttpServlet {
    private static final String CONTENT_TYPE = "text/html; charset=windows-1252";
    @EJB private HrmSessionEJB hrmFacade;

    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response) throws ServletException,
                                                           IOException {
        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head><title>ShowEmployees</title></head>");
      out.println("<body>");
      out.println("<h1>Employees</h1>");
      boolean refresh = false;
      Object refreshParam  = request.getParameterMap().get("refresh");
      if (refreshParam instanceof String[] && ((String[])refreshParam).length>0) {
        refresh = "true".equals(((String[])refreshParam)[0]);
      }
        if (refresh) {
          hrmFacade.refreshAllCachedEntities();
        }
        List<Employee> employees = hrmFacade.getEmployeeFindAll();
        for (Employee employee:employees) {
          out.println("<p>"+employee.getEname()+"</p>");
            
        }
        
        out.println("</body></html>");
        out.close();
    }
}
