package nl.amis.hrm.model;

import java.sql.Connection;

import java.sql.SQLException;

import java.util.List;

import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateless;

import javax.naming.Context;

import javax.naming.InitialContext;

import javax.naming.NamingException;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import javax.sql.DataSource;

import oracle.jdbc.OracleConnection;

import org.eclipse.persistence.jpa.JpaEntityManager;

@Stateless(name = "HrmSessionEJB", mappedName = "ActiveWebCache-Model-HrmSessionEJB")
@Remote
@Local
public class HrmSessionEJBBean implements HrmSessionEJB, HrmSessionEJBLocal {
    @PersistenceContext(unitName="HrmPU")
    private EntityManager em;

    public HrmSessionEJBBean() {
    }

    public Object queryByRange(String jpqlStmt, int firstResult,
                               int maxResults) {
        Query query = em.createQuery(jpqlStmt);
        if (firstResult > 0) {
            query = query.setFirstResult(firstResult);
        }
        if (maxResults > 0) {
            query = query.setMaxResults(maxResults);
        }
        return query.getResultList();
    }

    public Employee persistEmployee(Employee employee) {
        em.persist(employee);
        return employee;
    }

    public Employee mergeEmployee(Employee employee) {
        return em.merge(employee);
    }

    public void removeEmployee(Employee employee) {
        employee = em.find(Employee.class, employee.getEmpno());
        em.remove(employee);
    }

    /** <code>select o from Employee o</code> */
    public List<Employee> getEmployeeFindAll() {
        return em.createNamedQuery("Employee.findAll").getResultList();
    }

    public Department persistDepartment(Department department) {
        em.persist(department);
        return department;
    }

    public Department mergeDepartment(Department department) {
        return em.merge(department);
    }

    public void removeDepartment(Department department) {
        department = em.find(Department.class, department.getDeptno());
        em.remove(department);
    }

    /** <code>select o from Department o</code> */
    public List<Department> getDepartmentFindAll() {
        return em.createNamedQuery("Department.findAll").getResultList();
    }

    public void refreshAllCachedEntities() {
      ((JpaEntityManager)em.getDelegate()).getServerSession().getIdentityMapAccessor().invalidateAll();
    }
    
    public OracleConnection getEMsConnection() {

      String jndiName = "java:/app/jdbc/jdbc/ScottXPVMDS";
      //return ((oracle.toplink.essentials.ejb.cmp3.EntityManager) em).getServerSession().getDefaultConnectionPool().acquireConnection().getConnection();
      System.out.println(em);
      Context ctx=null;
        try {
            ctx = new InitialContext();
        } catch (NamingException e) {
        }
      DataSource ds=null;
        try {
            ds = (DataSource)ctx.lookup("java:/" + jndiName);
        } catch (NamingException e) {
        }
        OracleConnection conn=null;
        try {
            conn = (OracleConnection)ds.getConnection();
        } catch (SQLException e) {
        }
        return conn;
    }
}
