begin
DBMS_FGA.DROP_POLICY (
   object_schema      =>  'scott', 
   object_name        =>  'emp', 
   policy_name        =>  'income_audit_policy'
   ); 
end;


begin
DBMS_FGA.ADD_POLICY (
   object_schema      =>  'scott', 
   object_name        =>  'emp', 
   policy_name        =>  'income_audit_policy', 
   audit_condition    =>  'sal >2000 ', 
   audit_column       =>  'comm,sal', 
   handler_schema     =>   NULL, 
   handler_module     =>   NULL, 
   enable             =>   TRUE, 
   statement_types    =>  'SELECT, INSERT, UPDATE', 
   audit_trail        =>   DBMS_FGA.XML + DBMS_FGA.EXTENDED, 
   audit_column_opts  =>   DBMS_FGA.ANY_COLUMNS
   ); 
end;


select ename
,      sal
from   emp
where  sal > 2100




select 
from V$XML_AUDIT_TRAIL


DBA_COMMON_AUDIT_TRAIL





create table emp_audit
( whodidit varchar2(40)
, whenwasit timestamp
, sql_executed varchar2(4000)
)
/

create or replace 
package AUDIT_HANDLER
is
PROCEDURE HANDLE_EMP_SAL_ACCESS
( object_schema VARCHAR2
, object_name VARCHAR2
, policy_name VARCHAR2 
);
end;
/

create or replace 
package body AUDIT_HANDLER
is
PROCEDURE HANDLE_EMP_SAL_ACCESS
( object_schema VARCHAR2
, object_name VARCHAR2
, policy_name VARCHAR2 
) is
  PRAGMA AUTONOMOUS_TRANSACTION;
begin
  insert into emp_audit  
  ( whodidit, whenwasit, sql_executed)
  values
  ( user, systimestamp, sys_context('userenv','current_sql'))
  ;
  commit;
end HANDLE_EMP_SAL_ACCESS;
end;
/


--NOTE: schema needs access to dbms_fga
-- connect as sys
-- grant execute on dbms_fga to scott

begin 
  dbms_fga.add_policy 
  ( object_schema=>'SCOTT'
  , object_name=>'EMP' 
  , policy_name=>'SAL_ACCESS_HANDLED'
  , audit_column => 'SAL'
  , audit_condition => 'SAL>= 1500'
  , handler_schema => 'SCOTT'
  , handler_module => 'AUDIT_HANDLER.HANDLE_EMP_SAL_ACCESS' 
  );
end;
/

select ename
from   emp
/

select *
from   emp_audit
/


select ename
,      sal
from   emp 
where  sal < 1500
/

select *
from   emp_audit
/

select ename
from   emp
where  job = 'PRESIDENT'
/

select *
from   emp_audit
/
select ename
,      sal
from   emp
where  job = 'PRESIDENT'
/

select *
from   emp_audit
/
