set echo on
set feedback on

grant execute on DBMS_CQ_NOTIFICATION to scott;
grant execute on DBMS_CHANGE_NOTIFICATION to scott;

grant CHANGE NOTIFICATION to scott;


ALTER SYSTEM SET "JOB_QUEUE_PROCESSES"=4
/





DECLARE
  l_reg_info CQ_NOTIFICATION$_REG_INFO;
  v_cursor SYS_REFCURSOR;
  l_regid number(10);
BEGIN
  -- Create object:

  l_reg_info := CQ_NOTIFICATION$_REG_INFO (
    'SCOTT.dcn_callback',                 -- PL/SQL notification handler
    DBMS_CQ_NOTIFICATION.QOS_QUERY     -- notification type QRCN
    + DBMS_CQ_NOTIFICATION.QOS_ROWIDS, -- include rowids of changed objects
    0,                          -- registration persists until unregistered
    0,                          -- notify on all operations
    0                           -- notify immediately
    );

  -- Register queries:
  l_regid := DBMS_CQ_NOTIFICATION.new_reg_start(l_reg_info);
  -- Open existing registration
  DBMS_CQ_NOTIFICATION.ENABLE_REG(l_regid);

  OPEN v_cursor FOR
    SELECT dbms_cq_notification.CQ_NOTIFICATION_QUERYID, 
        sal, job, comm
    from   emp
    where  sal > 2500
    ;
  CLOSE v_cursor;
  -- Close registration
  DBMS_CQ_NOTIFICATION.REG_END;
END;
/

SELECT REGID, TABLE_NAME 
FROM   USER_CHANGE_NOTIFICATION_REGS
/



create table notifications
( reg_id varchar2(30)
, transaction_id varchar2(30)
, time_of_change timestamp default systimestamp
, table_name varchar2(1000)
, row_id varchar2(2000)
, operation_type varchar2(50)
)
/


CREATE OR REPLACE PROCEDURE dcn_callback
  (ntfnds IN CQ_NOTIFICATION$_DESCRIPTOR)
IS
 regid           NUMBER;
 transactionid           varchar2(100);
  tbname          VARCHAR2(60);
  event_type      NUMBER;
  numtables       NUMBER;
  operation_type  NUMBER;
  numrows         NUMBER;
  row_id          VARCHAR2(2000);
  numqueries      NUMBER;
  qid NUMBER;
  qop NUMBER;
BEGIN
  regid := ntfnds.registration_id;
  transactionid := ntfnds.transaction_id;
  event_type := ntfnds.event_type;
          INSERT INTO notifications (reg_id, transaction_id)  
          VALUES(regid,transactionid );
   IF (event_type = DBMS_CQ_NOTIFICATION.EVENT_QUERYCHANGE) THEN
    numqueries := ntfnds.query_desc_array.count;
    FOR i IN 1..numqueries LOOP
      numtables := ntfnds.query_desc_array(i).table_desc_array.count;
      FOR j IN 1..numtables LOOP
        tbname :=
          ntfnds.query_desc_array(i).table_desc_array(j).table_name;
        operation_type :=
          ntfnds.query_desc_array(i).table_desc_array(j).Opflags;
numrows := ntfnds.query_desc_array(i).table_desc_array(j).numrows;
 FOR k IN 1..numrows LOOP
          Row_id :=
 ntfnds.query_desc_array(i).table_desc_array(j).row_desc_array(k).row_id;
          INSERT INTO notifications (reg_id, transaction_id, table_name, row_id, operation_type)  
          VALUES(regid,transactionid , tbname, Row_id, operation_type);
        END LOOP;  -- loop over rows
      END LOOP;  -- loop over tables
    END LOOP;  -- loop over queries
    end if;
  COMMIT;
END;
/

update emp
set    sal = sal + 100
/

commit;

select * 
from   notifications
/

