
alter table emp
add constraint check_comm_under_30perc
check (nvl(comm,0) < 0.3* sal)



ALTER TABLE
   patient
ADD (
   CONSTRAINT
      phone_number_format
   CHECK
       (REGEXP_LIKE(patient_phone,
        '^\([[:digit:]]{3}\) [[:digit:]]{3}-[[:digit:]]{4}$')));
        
ALTER TABLE
   EMP
ADD (
   CONSTRAINT
      email_address
   CHECK
       (REGEXP_LIKE (text, '[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{2,4}'))
       
       
       

create type number_tbl as table of number



   
create or replace
procedure val_salmax_in_dept
( p_deptno in number
) is
  l_bad_count number;
begin
  select count(*)
  into   l_bad_count
  from   ( select avg(sal) sal_avg
           ,      max(sal) max_sal
           from   emp
           where  deptno = p_deptno
         )
  where  max_sal >= 1.8 * sal_avg;
  if l_bad_count > 0
  then
    raise_application_error( -20099, 'Business Rule Violation: in Department '||p_deptno
                           ||': Maximum Salary may not be more than 1.8 times average');
  end if;
end val_salmax_in_dept; 


create or replace 
trigger br_on_emp_ctrg
for insert or update or delete on emp
compound trigger 
  l_deptno_tbl number_tbl:= number_tbl();
  before statement is
  begin
    null;
  end before statement;
  before each row is
  begin
    if updating('DEPTNO')
    then
      l_deptno_tbl.extend();
      l_deptno_tbl(l_deptno_tbl.last):= :old.deptno;
    end if;
      l_deptno_tbl.extend();
      l_deptno_tbl(l_deptno_tbl.last):= nvl(:new.deptno, :old.deptno);
  end before each row;
  after each row is
  begin
    null;
  end after each row;
  after statement is
  begin
    for i in 1.. l_deptno_tbl.last loop 
      val_salmax_in_dept(l_deptno_tbl(i));
    end loop;
  end after statement;
end br_on_emp_ctrg;


rem 
rem grant CREATE ANY MATERIALIZED VIEW to scott


create table emp3 as select * from emp2
/

alter table emp3 add constraint emp3_pk primary key (empno)
/

drop materialized view log on emp3
/


create materialized view log on emp3 
WITH SEQUENCE , PRIMARY KEY, ROWID ( deptno, sal, job, hiredate, ename, comm, mgr) including new values
/


create materialized view emp_deptsalsum_mv 
refresh fast on commit 
as 
select deptno 
,      sum(sal) sumsal 
,      count(*) 
,      count(sal) head_count 
from   emp3 
group 
by     deptno
/

select * from emp_deptsalsum_mv 


alter table emp_deptsalsum_mv 
add constraint check_dept_salsum 
check ( sumsal < 20000) 
deferrable 
/ 
update emp 
set sal = sal* 2 
/ 
commit 
/



create table t_emp
 (empno number
 ,ename varchar2(10)
 ,constraint t_emp_pk  primary key (empno)
 );

insert into t_emp values (1,'sam'); 
insert into t_emp values (2,'joe'); 

update t_emp 
   set empno = empno + 1;

insert into t_emp values (2,'bob'); 
   
   
alter table t_emp
drop constraint t_emp_pk 


alter table t_emp
add constraint t_emp_pk primary key (empno) deferrable initially deferred
 
 
insert into t_emp values (2,'bob'); 

commit
