package nl.amis.plsql.entities;

import java.io.Serializable;

import java.sql.Struct;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

import org.eclipse.persistence.annotations.Direction;
import org.eclipse.persistence.annotations.NamedStoredProcedureQueries;
import org.eclipse.persistence.annotations.NamedStoredProcedureQuery;
import org.eclipse.persistence.annotations.StoredProcedureParameter;

@Entity
@NamedQueries( { @NamedQuery(name = "Greeter.findAll",
                             query = "select o from Greeter o") })
@NamedStoredProcedureQueries({
@NamedStoredProcedureQuery(name = "RetrieveGreeting",
                           procedureName = "hello_world_proc",
                           parameters = { @StoredProcedureParameter(queryParameter =  "P_NAME",
                                                                    direction = Direction.IN,
                                                                    type = String.class),
                                          @StoredProcedureParameter(queryParameter =  "P_GREETING",
                                                                    direction = Direction.OUT, 
                                                                    type = String.class) 
})
,@NamedStoredProcedureQuery(name = "RetrieveEmployee",
                           procedureName = "get_employee",
                           parameters = { @StoredProcedureParameter(queryParameter =  "P_NO",
                                                                    direction = Direction.IN,
                                                                    type = Integer.class),
                                          @StoredProcedureParameter(queryParameter =  "P_EMPLOYEE",
                                                                    direction = Direction.OUT, 
                                                                    type = Struct.class, jdbcTypeName="EMPLOYEE_TYPE") 
})
, @NamedStoredProcedureQuery(name = "RETRIEVE_HRM_VIA_CURSOR", procedureName = "hrm_details", returnsResultSet = false,
                           parameters = {@StoredProcedureParameter( queryParameter = "t_cursor", name = "t_cursor"
                                                                  , direction = Direction.OUT_CURSOR)
                                         }
                             )

}
)

public class Greeter implements Serializable {
    @Column(length = 4000)
    @Id
    private String greeting;

    public Greeter() {
    }

    public Greeter(String greeting) {
        this.greeting = greeting;
    }

    public String getGreeting() {
        return greeting;
    }

    public void setGreeting(String greeting) {
        this.greeting = greeting;
    }
}
