rem BR Salary Increase smaller than 10% in one transaction
rem Note: row level update trigger cannot enforce this constraint!

create or replace
function sal_raise_check
( p_sal   in number
, p_empno in number
) return varchar2
deterministic
is
  -- also required when used from deferred constraint?? 
  pragma autonomous_transaction;
  l_old_sal number(10,2);
begin
  select sal
  into   l_old_sal
  from   emp
  where  empno = p_empno
  ;
  return case 
         when nvl(p_sal,0) < 1.1 * nvl(l_old_sal,p_sal) then 'Y'
         else 'N'
         end; 
exception
  when no_data_found
  then
    return 'Y'; -- probably an insert, no problem with that
end;
/


alter table emp
ADD (sal_raise_chk AS (sal_raise_check(sal, empno)))
/

alter table emp add constraint emp_sal_raise_chk 
check ( sal_raise_chk = 'Y')
/

update emp
set    sal = sal * 1.05
/

commit;

update emp
set    sal = sal * 1.15
/

commit;

update emp
set    sal = sal + 500
/

commit;

update emp
set    sal = sal* 1.08
/

update emp
set    sal = sal* 1.07
/

commit
/

update emp
set    sal = sal* 1/1.05
/

commit
/

alter table emp drop constraint emp_sal_raise_chk
/

alter table emp drop column sal_raise_chk
/
