drop table accounts
/
create table accounts
(acctno number
,acct_name varchar2(25)
,balance number
);

insert into accounts values (1, 'BILL', 1000);
insert into accounts values (2, 'CHUCK', 1600);
insert into accounts values (3, 'DARLENE', 1500);

create or replace
function vpd_pol_func (p_schema in varchar2
                      ,p_table in varchar2
                      )
   return varchar2
is
begin
   return 'balance < 1600';
end vpd_pol_func;
/

cl scr

select *
  from accounts
/

set echo off

begin
   dbms_rls.add_policy (object_schema   => 'SCOTT'
                       ,object_name     => 'ACCOUNTS'
                       ,policy_name     => 'Limit Balance'
                       ,policy_function => 'VPD_POL_FUNC'
                       ,function_schema => 'SCOTT'
                       ,statement_types => 'SELECT'
                       ,update_check    => false
                       ,enable          => true
                       ,static_policy   => true
                       ,sec_relevant_cols => 'BALANCE' -- 'ACCT_NAME' -- 
                       ,sec_relevant_cols_opt => dbms_rls.ALL_ROWS
                       );
end;
/

set echo on

pause


select *
  from accounts
/

select acctno
     , acct_name
  from accounts
/

select acctno
     , acct_name
  from accounts
 where balance > 1600
/

pause
cl scr

drop table accounts
/

cl scr
