begin
dbms_rls.drop_policy
( object_schema => 'SCOTT'
, object_name => 'JOB_TITLES'
, policy_name => 'JOB_TITLELANGUAGE_POLICY'
);
end;
/


create table job_titles
( job varchar2(15)
, language varchar2(2)
, title varchar2(50)
)
/

insert into job_titles
values
('CLERK','en','CLERK')
/
insert into job_titles
values
('CLERK','nl','SECRETARESSE')
/
insert into job_titles
values
('CLERK','fa','SECRETAIRE')
/
insert into job_titles
values
('SALESMAN','nl','VERKOPER')
/
insert into job_titles
values
('SALESMAN','en','SALESMAN')
/
insert into job_titles
values
('SALESMAN','fa','VENDEUR')
/
insert into job_titles
values
('MANAGER','en','MANAGER')
/
insert into job_titles
values
('MANAGER','nl','BAAS')
/
insert into job_titles
values
('MANAGER','fa','CHEF')
/
insert into job_titles
values
('ANALYST','nl','UITZOEKER')
/
insert into job_titles
values
('ANALYST','en','ANALYST')
/
insert into job_titles
values
('ANALYST','fa','RECHERCHEUR')
/

select e.ename
, j.title
from emp e
, job_titles j
where e.job = j.job
/

pause


create or replace package hrm_pkg
is
procedure set_language
( p_language in varchar2
);
end;
/
create or replace package body hrm_pkg
is
procedure set_language
( p_language in varchar2
) is
begin
dbms_session.set_context('HRM_CTX' , 'LANGUAGE' ,p_language);
end set_language;

function get_language
return varchar2
is
begin
return sys_context('HRM_CTX' , 'LANGUAGE');
end get_language;

end;
/

pause


create or replace context hrm_ctx using hrm_pkg
/
rem ( as SYS: grant create any context to scott)

create or replace function get_job_title_predicate
( p_schema_name in varchar2
, p_table_name in varchar2
) return varchar2
is
l_ctx varchar2(10):= 'HRM_CTX' ;
begin
return 'language = sys_context('''||l_ctx||''', ''LANGUAGE'')';
end;
/

pause

begin
dbms_rls.add_policy
( object_schema => 'SCOTT'
, object_name => 'JOB_TITLES'
, policy_name => 'JOB_TITLELANGUAGE_POLICY'
, policy_function => 'GET_JOB_TITLE_PREDICATE'
, function_schema => 'SCOTT'
, statement_types => 'SELECT'
, update_check => false
, enable => true
);
end;
/


pause

select e.ename
, j.title
from emp e
, job_titles j
where e.job = j.job


pause

/

begin
hrm_pkg.set_language('en');
end;
/

select e.ename
, j.title
from emp e
, job_titles j
where e.job = j.job

pause

/

begin
hrm_pkg.set_language('nl');
end;
/

select e.ename
, j.title
from emp e
, job_titles j
where e.job = j.job

pause

/


pause

select * from session_context
/

rem tear down

begin
dbms_rls.drop_policy
( object_schema => 'SCOTT'
, object_name => 'JOB_TITLES'
, policy_name => 'JOB_TITLELANGUAGE_POLICY'
);
end;
/

drop table job_titles
/


