rem trees

select lpad(' ',level*2)||e.empno empid
     , e.ename
     , e.mgr
     , e.deptno
from emp e 
connect by prior empno = mgr
  start  with mgr is null

select lpad(' ', 2*level-1)||
       sys_connect_by_path
           (ename, '/') "path"
  from emp
 start with ename = 'KING'
connect by prior empno = mgr




create table points
( id    number(5)
, name  varchar2(30)
)
/

rem generating rows

insert into points
( id, name)
select level
,      chr(64+level) -- capital , starting with A (chr(65))
from   dual
connect
by     level < 6
/


create table connections
( from_id number(5)
, to_id   number(5)
, distance number(5)
)
/



insert into connections
( from_id, to_id, distance)
values
(1,2,3)
/

insert into connections
( from_id, to_id, distance)
values
(1,3,6)
/

insert into connections
( from_id, to_id, distance)
values
(2,4,5)
/

insert into connections
( from_id, to_id, distance)
values
(2,5,2)
/

insert into connections
( from_id, to_id, distance)
values
(3,4,1)
/

insert into connections
( from_id, to_id, distance)
values
(3,5,2)
/



rem list connections


select from_point.name from_point
,      to_point.name   to_point
,      conn.distance  distance
from   points from_point
       join
       connections conn
	   on ( conn.from_id = from_point.id)
	   join
       points to_point
       on (conn.to_id = to_point.id)
/
	   
rem navigate across point_connections, starting at the from side

with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip


rem show the path you are walking

with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
,      sys_connect_by_path(to_point,'/') path
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip
/



with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') path
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip
/


with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') path
,      sys_connect_by_path(distance,'/') distances
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip
/




with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') path
,      sys_connect_by_path(distance,'+') total_distance
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip
/


select xmlcast( xmlquery( substr('+1+3+7+2',2) 
                           returning content )
                      as number(4)
                    ) 
from   dual
/					

with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
select level number_of_transfers
,      from_point node_from
,      to_point   node_to
,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') path
,      sys_connect_by_path(distance,'+') distances
,      xmlcast( xmlquery( substr( sys_connect_by_path(distance,'+'),2) 
                           returning content )
               as number(4)
              )  total_distance
from   point_connections pc
connect
by     nocycle prior to_point = from_point
start
with   from_point = 'A'  -- starting point of the trip
/


with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
, routes as
( select level number_of_transfers
  ,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') route
  ,      sys_connect_by_path(distance,'+') distances
  ,      xmlcast( xmlquery( substr( sys_connect_by_path(distance,'+'),2) 
                             returning content )
                 as number(4)
                )  total_distance
  from   point_connections pc
  connect
  by     nocycle prior to_point = from_point
  start
  with   from_point = 'A'  -- starting point of the trip
)
select *
from   routes
where  regexp_like(route,'D$') -- D is the final destination
order
by     total_distance
/

rem add road from E to D

insert into connections
( from_id, to_id, distance)
values
(5,4,1)
/



with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
, routes as
( select level number_of_transfers
  ,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') route
  ,      sys_connect_by_path(distance,'+') distances
  ,      xmlcast( xmlquery( substr( sys_connect_by_path(distance,'+'),2) 
                             returning content )
                 as number(4)
                )  total_distance
  from   point_connections pc
  connect
  by     nocycle prior to_point = from_point
  start
  with   from_point = 'A'  -- starting point of the trip
)
select *
from   routes
where  regexp_like(route,'D$') -- D is the final destination
order
by     total_distance
/

alter table connections
add (average_speed number(3) )
/


update  connections
set  average_speed = 30 * dbms_random.value + 40
/


select from_point.name from_point
,      to_point.name   to_point
,      conn.distance   distance
,      conn.average_speed   speed
,      distance/average_speed travelling_time
from   points from_point
       join
       connections conn
	   on ( conn.from_id = from_point.id)
	   join
       points to_point
       on (conn.to_id = to_point.id)
/

with point_connections as
( select from_point.name from_point
 ,      to_point.name   to_point
 ,      conn.distance  distance
 ,      round(distance/average_speed,2) travelling_time
 from   points from_point
        join
        connections conn 
  	    on ( conn.from_id = from_point.id)
	    join
        points to_point
        on (conn.to_id = to_point.id)
)
, routes as
( select level number_of_transfers
  ,      CONNECT_BY_ROOT from_point||sys_connect_by_path(to_point,'/') route
  ,      sys_connect_by_path(distance,'+') distances
  ,      sys_connect_by_path(travelling_time,'+') times
  ,      xmlcast( xmlquery( substr( sys_connect_by_path(distance,'+'),2) 
                             returning content )
                 as number(4)
                )  total_distance
  ,      xmlcast( xmlquery( substr( sys_connect_by_path(travelling_time,'+'),2) 
                             returning content )
                 as number(4,2)
                )  total_travelling_Time
  from   point_connections pc
  connect
  by     nocycle prior to_point = from_point
  start
  with   from_point = 'A'  -- starting point of the trip
)
select *
from   routes
where  regexp_like(route,'D$') -- D is the final destination
order
by     total_travelling_time
/


drop table points
/

drop table connections
/



WITH
  emp_tree  (empid, name, mgrid, lev) AS
  (
    SELECT empno, ename, mgr , 1
    FROM emp
    WHERE mgr is null
  UNION ALL
    SELECT empno, ename, mgr, lev+1
    FROM emp_tree r, emp e
    WHERE r.empid = e.mgr
  )
select lpad('*', lev * 2)||e.name
,      empid
,      mgrid
from   emp_tree e
/
