set feedback on

cl scr

prompt UNPIVOT - FROM COLUMNS TO ROWS

select ename, job, sal, comm
from   emp
/


pause




select *
from   ( select ename, job, sal, comm
         from   emp
       )
       unpivot
       ( income_component_value
         for income_component_type in (sal, comm)
       )

pause

/


prompt Measurements
pause

cl scr

create table daily_measurements
( day date
, morning_measurement number(5,2)
, afternoon_measurement number(5,2)
, evening_measurement number(5,2)
)
/

pause

insert into daily_measurements
( day 
, morning_measurement 
, afternoon_measurement 
, evening_measurement 
)
values
(sysdate -3
, 10.2
, 45.91
, 35.6
)
/

insert into daily_measurements
( day 
, morning_measurement 
, afternoon_measurement 
, evening_measurement 
)
values
(sysdate -2
, 16.12
, 25.13
, 38.21
)
/

insert into daily_measurements
( day 
, morning_measurement 
, afternoon_measurement 
, evening_measurement 
)
values
(sysdate -1
, 21.65
, null
, 81.2
)
/


select *
from   daily_measurements
/

prompt How to display a list of all measurements?

pause

select *
from   daily_measurements
       unpivot include nulls
       ( measurement 
         for measurement_time in ( morning_measurement 
                                 , afternoon_measurement 
                                 , evening_measurement 
                                 )
       )
/


prompt How to calculate the average measurement value?

pause

select avg(measurement)
from   daily_measurements
       unpivot 
       ( measurement
         for measurement_time in ( morning_measurement 
                                 , afternoon_measurement 
                                 , evening_measurement 
                                 )
       )
/

pause

drop table daily_measurements
/

